<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2005 Invision Power Services, Inc.
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   =============================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Wed, 04 Jan 2006 19:53:17 GMT
|   Release: 2d174325a5cb8288fdab03b953f0e659
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|   > $Date: 2005-10-10 14:08:54 +0100 (Mon, 10 Oct 2005) $
|   > $Revision: 23 $
|   > $Author: matt $
+---------------------------------------------------------------------------
|
|   > API: Languages
|   > Module written by Matt Mecham
|   > Date started: Wednesday 30th November 2005 (11:40)
|
+--------------------------------------------------------------------------
*/

/**
* API: Forums
*
* EXAMPLE USAGE
* <code>
* To follow
* </code>
*
* @package		InvisionPowerBoard
* @subpackage	APIs
* @author		Matt Mecham
* @copyright	Invision Power Services, Inc.
* @version		2.1
*/

if ( ! defined( 'IPS_API_PATH' ) )
{
	/**
	* Define classes path
	*/
	define( 'IPS_API_PATH', dirname(__FILE__) ? dirname(__FILE__) : '.' );
}

if ( ! class_exists( 'api_core' ) )
{
	require_once( IPS_API_PATH.'/api_core.php' );
}

/**
* API: Languages
*
* This class deals with all available language functions.
*
* @package		InvisionPowerBoard
* @subpackage	APIs
* @author  	 	Matt Mecham
* @version		2.1
* @since		2.1.0
*/
class api_forums extends api_core
{
	/**
	* IPS Class Object
	*
	* @var object
	*/
	//var $ipsclass;
	
	
	/*-------------------------------------------------------------------------*/
	// Returns a forum jump option list
	/*-------------------------------------------------------------------------*/
	/**
	* Returns a forum jump list WITHOUT the SELECT tag
	* NOTE: Returns ALL forums regardless of permission as
	* if viewed from the ACP.
	*
	* @param	array 	Array of selected IDs
	* @return   string	HTML <option> list of forums;
	*/
	function return_forum_jump_option_list( $selected=array() )
	{
		//-----------------------------------------
		// Get forums...
		//-----------------------------------------
	
		$this->ipsclass->forums->forums_init();
		
		$content = $this->ipsclass->forums->forums_forum_jump( 0, 0, 1 );
		
		//-----------------------------------------
		// Splice in selected IDs
		//-----------------------------------------
		
		if ( is_array( $selected ) and count( $selected ) )
		{
			foreach( $selected as $id )
			{
				$content = preg_replace( "#value=([\"'])($id)[\"']#si", "value=\\1\\2\\1 selected='selected'", $content );
			}
		}
		
		//-----------------------------------------
		// Return...
		//-----------------------------------------
		
		return $content;
	}
	
	
	
	
	
	
	
	
	
}



?>