<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services, Inc.
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   =============================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Sun, 09 Oct 2005 11:51:26 GMT
|   Release: 1a47e28f0443faa9f14d0c0a45151e54
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > Post Sub-Class
|   > Module written by Matt Mecham
|   > Date started: Wednesday 9th March 2005 (15:23)
|
+--------------------------------------------------------------------------
*/

class post_functions extends class_post
{
	var $nav       = array();
	var $title     = "";
	var $post      = array();
	var $upload    = array();
	var $mod_topic = array();
	var $class     = "";
	var $m_group   = "";
	var $post_key  = "";
	
	var $has_poll       = 0;
	var $poll_questions = array();
	
	/*-------------------------------------------------------------------------*/
	// Sub class init
	/*-------------------------------------------------------------------------*/
	
	function main_init()
	{
		//-----------------------------------------
		// Load classes
		//-----------------------------------------
		
		$this->load_classes();
		$this->build_permissions();
		
		//-----------------------------------------
		// Check permissions
		//-----------------------------------------
		
		$this->post_key = $this->ipsclass->input['post_key'] ? $this->ipsclass->input['post_key'] : md5(microtime());
		
		$this->check_for_new_topic();
	}
	
	/*-------------------------------------------------------------------------*/
	// MAIN PROCESS FUNCTION
	/*-------------------------------------------------------------------------*/
	
	function process_post()
	{
		//-----------------------------------------
		// Convert times...
		//-----------------------------------------
		
		$this->convert_open_close_times();
		
		//-----------------------------------------
		// Did we remove an attachment?
		//-----------------------------------------
		
		if ( $this->ipsclass->input['removeattachid'] )
		{
			if ( $this->ipsclass->input[ 'removeattach_'. $this->ipsclass->input['removeattachid'] ] )
			{
				$this->pf_remove_attachment( intval($this->ipsclass->input['removeattachid']), $this->post_key );
				$this->show_form();
			}
		}
		
		//-----------------------------------------
		// Did we add an attachment?
		//-----------------------------------------
		
		if ( $this->ipsclass->input['attachgo'] )
		{
			$this->obj['post_errors'] = "";
			$this->upload_id = $this->process_upload();
			$this->show_form();
		}
		
		//-----------------------------------------
		// Parse the post, and check for any errors.
		//-----------------------------------------
		
		$this->post = $this->compile_post();
		
		//-----------------------------------------
		// check to make sure we have a valid topic title
		//-----------------------------------------
		
		$this->ipsclass->input['TopicTitle'] = str_replace( "<br />", "", $this->ipsclass->input['TopicTitle'] );
		
		$this->ipsclass->input['TopicTitle'] = trim($this->ipsclass->input['TopicTitle']);
		
		//-----------------------------------------
		// More unicode..
		//-----------------------------------------
		
		$temp = $this->ipsclass->txt_stripslashes($_POST['TopicTitle']);
		
		if ( $this->ipsclass->txt_mb_strlen($_POST['TopicTitle']) > $this->ipsclass->vars['topic_title_max_len'] )
		{
			$this->obj['post_errors'] = 'topic_title_long';
		}
		
		if ( (strlen($temp) < 2) or (!$this->ipsclass->input['TopicTitle'])  )
		{
			$this->obj['post_errors'] = 'no_topic_title';
		}
		
		//-----------------------------------------
		// Compile the poll
		//-----------------------------------------
		
		$this->poll_questions = $this->compile_poll();
		
		//-----------------------------------------
		// If we don't have any errors yet, parse the upload
		//-----------------------------------------
		
		if ($this->obj['post_errors'] == "")
		{
			$this->upload = $this->process_upload();
		}
		
		if ( ($this->obj['post_errors'] != "") or ( $this->obj['preview_post'] != "" ) )
		{
			//-----------------------------------------
			// Show the form again
			//-----------------------------------------
			
			$this->show_form();
		}
		else
		{
			$this->save_post();
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// ADD TOPIC FUNCTION
	/*-------------------------------------------------------------------------*/
	
	function save_post()
	{
		//-----------------------------------------
		// Fix up the topic title
		//-----------------------------------------
		
		$this->ipsclass->input['TopicTitle'] = $this->pf_clean_topic_title( $this->ipsclass->input['TopicTitle'] );
		
		$this->ipsclass->input['TopicTitle'] = $this->parser->bad_words( $this->ipsclass->input['TopicTitle'] );
		$this->ipsclass->input['TopicDesc']  = $this->parser->bad_words( $this->ipsclass->input['TopicDesc']  );
		
		$pinned = 0;
		$state  = 'open';
		
		if ( ($this->ipsclass->input['mod_options'] != "") or ($this->ipsclass->input['mod_options'] != 'nowt') )
		{
			if ($this->ipsclass->input['mod_options'] == 'pin')
			{
				if ($this->ipsclass->member['g_is_supmod'] == 1 or $this->moderator['pin_topic'] == 1)
				{
					$pinned = 1;
					
					$this->moderate_log('     ', $this->ipsclass->input['TopicTitle']);
				}
			}
			else if ($this->ipsclass->input['mod_options'] == 'close')
			{
				if ($this->ipsclass->member['g_is_supmod'] == 1 or $this->moderator['close_topic'] == 1)
				{
					$state = 'closed';
					
					$this->moderate_log('     ', $this->ipsclass->input['TopicTitle']);
				}
			}
			else if ($this->ipsclass->input['mod_options'] == 'pinclose')
			{
				if ($this->ipsclass->member['g_is_supmod'] == 1 or ( $this->moderator['pin_topic'] == 1 AND $this->moderator['close_topic'] == 1 ) )
				{
					$pinned = 1;
					$state = 'closed';
					
					$this->moderate_log('       ', $this->ipsclass->input['TopicTitle']);
				}
			}
		}
		
		//-----------------------------------------
		// Check close times...
		//-----------------------------------------
		
		if ( $state == 'open' AND ( $this->times['open'] OR $this->times['close'] )
				AND ( $this->times['close'] <= time() OR ( $this->times['open'] > time() AND !$this->times['close'] ) ) )
		{
			$state = 'closed';
		}
		
		//-----------------------------------------
		// Build the master array
		//-----------------------------------------
		
		$this->topic = array(
							  'title'            => $this->ipsclass->input['TopicTitle'],
							  'description'      => $this->ipsclass->input['TopicDesc'] ,
							  'state'            => $state,
							  'posts'            => 0,
							  'starter_id'       => $this->ipsclass->member['id'],
							  'starter_name'     => $this->ipsclass->member['id'] ?  $this->ipsclass->member['members_display_name'] : $this->ipsclass->input['UserName'],
							  'start_date'       => time(),
							  'last_poster_id'   => $this->ipsclass->member['id'],
							  'last_poster_name' => $this->ipsclass->member['id'] ?  $this->ipsclass->member['members_display_name'] : $this->ipsclass->input['UserName'],
							  'last_post'        => time(),
							  'icon_id'          => $this->ipsclass->input['iconid'],
							  'author_mode'      => $this->ipsclass->member['id'] ? 1 : 0,
							  'poll_state'       => ( count( $this->poll_questions ) AND $this->can_add_poll ) ? 1 : 0,
							  'last_vote'        => 0,
							  'views'            => 0,
							  'forum_id'         => $this->forum['id'],
							  'approved'         => ( $this->obj['moderate'] == 1 || $this->obj['moderate'] == 2 ) ? 0 : 1,
							  'pinned'           => $pinned,
							  'topic_open_time'  => $this->times['open'],
							  'topic_close_time' => $this->times['close'],
							 );
							
		//-----------------------------------------
		// Insert the topic into the database to get the
		// last inserted value of the auto_increment field
		// follow suit with the post
		//-----------------------------------------
		
		$this->ipsclass->DB->force_data_type = array( 'title'            => 'string',
													  'description'      => 'string',
													  'starter_name'     => 'string',
													  'last_poster_name' => 'string' );
		
		$this->ipsclass->DB->do_insert( 'topics', $this->topic );
		
		$this->post['topic_id']  = $this->ipsclass->DB->get_insert_id();
		$this->topic['tid']      = $this->post['topic_id'];
		
		//-----------------------------------------
		// Update the post info with the upload array info
		//-----------------------------------------
		
		$this->post['post_key']  = $this->post_key;
		$this->post['new_topic'] = 1;
		
		//-----------------------------------------
		// Unqueue the post if we're starting a new topic
		//-----------------------------------------
		
		$this->post['queued'] = 0;
		
		//-----------------------------------------
		// Add post to DB
		//-----------------------------------------
		
		$this->ipsclass->DB->do_insert( 'posts', $this->post );
	
		$this->post['pid'] = $this->ipsclass->DB->get_insert_id();
		
		//-----------------------------------------
		// Update topic with firstpost ID
		//-----------------------------------------
		
		$this->ipsclass->DB->simple_construct( array( 'update' => 'topics',
													  'set'    => "topic_firstpost=".$this->post['pid'],
													  'where'  => "tid=".$this->topic['tid']
											 )      );
							 
		$this->ipsclass->DB->simple_exec();
		
		//-----------------------------------------
		// Add the poll to the polls table
		//-----------------------------------------
		
		if ( count( $this->poll_questions ) AND $this->can_add_poll )
		{
			$this->ipsclass->DB->do_insert( 'polls', 
											array (
													  'tid'           => $this->topic['tid'],
													  'forum_id'      => $this->forum['id'],
													  'start_date'    => time(),
													  'choices'       => addslashes(serialize( $this->poll_questions )),
													  'starter_id'    => $this->ipsclass->member['id'],
													  'votes'         => 0,
													  'poll_question' => $this->ipsclass->input['poll_question'],
											)     );
		}
						 
		//-----------------------------------------
		// If we are still here, lets update the
		// board/forum stats
		//----------------------------------------- 
		
		$this->pf_update_forum_and_stats($this->topic['tid'], $this->topic['title'], 'new');
		
		//-----------------------------------------
		// Make attachments "permanent"
		//-----------------------------------------
		
		$this->pf_make_attachments_permanent($this->post_key, $this->topic['tid'], $this->post['pid']);
		
		//-----------------------------------------
		// If we are a member, lets update thier last post
		// date and increment their post count.
		//-----------------------------------------
		
		$this->pf_increment_user_post_count();
		
		//-----------------------------------------
		// Are we tracking new topics we start 'auto_track'?
		//-----------------------------------------
		
		$this->pf_add_tracked_topic($this->topic['tid']);
		
		//-----------------------------------------
		// Moderating?
		//-----------------------------------------
		
		if ( $this->obj['moderate'] == 1 OR $this->obj['moderate'] == 2 )
		{
			//-----------------------------------------
			// Redirect them with a message telling them the
			// post has to be previewed first
			//-----------------------------------------
			
			$this->notify_new_topic_approval( $this->topic['tid'], $this->topic['title'], $this->topic['starter_name'], $this->post['pid'] );
			
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['moderate_topic'], "act=SF&f={$this->forum['id']}" );
		}
		
		//-----------------------------------------
		// Are we tracking this forum? If so generate some mailies - yay!
		//-----------------------------------------
		
		$this->forum_tracker($this->forum['id'], $this->topic['tid'], $this->topic['title'], $this->forum['name'], $this->post['post'] );
		
		//-----------------------------------------
		// Redirect them back to the topic
		//-----------------------------------------
		
		$this->ipsclass->boink_it($this->ipsclass->base_url."showtopic={$this->topic['tid']}");
	}

	/*-------------------------------------------------------------------------*/
	// SHOW FORM
	/*-------------------------------------------------------------------------*/

	function show_form()
	{
		//-----------------------------------------
		// Are we quoting posts?
		//-----------------------------------------
		
		$raw_post = $this->check_multi_quote();
		
		//-----------------------------------------
		// Sort out the "raw" textarea input and make it safe incase
		// we have a <textarea> tag in the raw post var.
		//-----------------------------------------
		
		$topic_title = isset($_POST['TopicTitle']) ? $this->ipsclass->input['TopicTitle'] : "";
		$topic_desc  = isset($_POST['TopicDesc'])  ? $this->ipsclass->input['TopicDesc']  : "";
		
		//-----------------------------------------
		// Do we have any posting errors?
		//-----------------------------------------
		
		if ($this->obj['post_errors'])
		{
			$this->output .= $this->ipsclass->compiled_templates['skin_post']->errors( $this->ipsclass->lang[ $this->obj['post_errors'] ]);
		}
		
		if ( $this->obj['preview_post'] )
		{
			$this->output .= $this->ipsclass->compiled_templates['skin_post']->preview( $this->show_post_preview( $this->post['post'] ) );
		}
		
		$this->output .= $this->html_start_form( array( 1 => array( 'CODE'    , '01' ),
														2 => array( 'post_key', $this->post_key ),
											   )      );
		
		//-----------------------------------------
		// START TABLE
		//-----------------------------------------
		
		$this->output .= $this->ipsclass->compiled_templates['skin_post']->table_structure();
		
		$topic_title = $this->ipsclass->compiled_templates['skin_post']->topictitle_fields( array( 'TITLE' => $topic_title, 'DESC' => $topic_desc ) );
		
		$start_table = $this->ipsclass->compiled_templates['skin_post']->table_top( "{$this->ipsclass->lang['top_txt_new']} {$this->forum['name']}");
		
		$name_fields = $this->html_name_field();
		
		$post_box    = $this->html_post_body( $raw_post );
		
		$mod_options = $this->mod_options();
		
		$end_form    = $this->ipsclass->compiled_templates['skin_post']->EndForm( $this->ipsclass->lang['submit_new'] );
		
		$post_icons  = $this->html_post_icons();
		
		//-----------------------------------------
		// POLL BOX
		//-----------------------------------------
		
		if ( $this->can_add_poll )
		{
			//-----------------------------------------
			// Did someone hit preview / do we have
			// post info?
			//-----------------------------------------
			
			$poll_questions = "";
			$poll_choices   = "";
			$show_open      = 0;
			
			if ( is_array( $_POST['question'] ) and count( $_POST['question'] ) )
			{
				foreach( $_POST['question'] as $id => $question )
				{
					$poll_questions .= "\t{$id} : '".str_replace( "'", '&#39;', $question )."',\n";
				}
				
				$poll_question = $this->ipsclass->input['poll_question'];
				$show_open     = 1;
			}
			
			if ( is_array( $_POST['choice'] ) and count( $_POST['choice'] ) )
			{
				foreach( $_POST['choice'] as $id => $choice )
				{
					$poll_choices .= "\t'{$id}' : '".str_replace( "'", '&#39;', $choice )."',\n";
				}
			}
			
			//-----------------------------------------
			// Trim off trailing commas (Safari hates it)
			//-----------------------------------------
			
			$poll_questions = preg_replace( "#,(\n)?$#", "\\1", $poll_questions );
			$poll_choices   = preg_replace( "#,(\n)?$#", "\\1", $poll_choices );
			
			$poll_box = $this->ipsclass->compiled_templates['skin_post']->poll_box( $this->max_poll_questions, $this->max_poll_choices_per_question, $poll_questions, $poll_choices, $poll_votes, $show_open, $poll_question );
		}
		
		//-----------------------------------------
		// UPLOAD BOX
		//-----------------------------------------
		
		if ( $this->can_upload )
		{
			$upload_field = $this->html_build_uploads( $this->post_key, 'new' );
		}
		
		$this->output = str_replace( "<!--START TABLE-->" , $start_table  , $this->output );
		$this->output = str_replace( "<!--NAME FIELDS-->" , $name_fields  , $this->output );
		$this->output = str_replace( "<!--POST BOX-->"    , $post_box     , $this->output );
		$this->output = str_replace( "<!--POLL BOX-->"    , $poll_box     , $this->output );
		$this->output = str_replace( "<!--POST ICONS-->"  , $post_icons   , $this->output );
		$this->output = str_replace( "<!--UPLOAD FIELD-->", $upload_field , $this->output );
		$this->output = str_replace( "<!--MOD OPTIONS-->" , $mod_options  , $this->output );
		$this->output = str_replace( "<!--END TABLE-->"   , $end_form     , $this->output );
		$this->output = str_replace( "<!--TOPIC TITLE-->" , $topic_title  , $this->output );
		$this->output = str_replace( "<!--FORUM RULES-->" , $this->ipsclass->print_forum_rules($this->forum), $this->output );
		
		$this->output = $this->html_add_smilie_box( $this->output );
		
		//-----------------------------------------
		// Add in siggy buttons and such
		//-----------------------------------------
		
		$this->html_checkboxes('new', 0, $this->forum['id']);
		
		$this->title = $this->ipsclass->lang['posting_new_topic'];
		
		$this->show_post_navigation();
		
		$this->ipsclass->print->add_output( $this->output );
        $this->ipsclass->print->do_output( array( 'TITLE'    => $this->ipsclass->vars['board_name']." -> ".$this->title,
												  'JS'       => 1,
												  'NAV'      => $this->nav,
										 )     );
	}
}

?>